SHEBANG
# Copyright @BABOLO (C)2002,2003 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2008/12/17 04:12:51 babolo Exp $

JNTROSTUP(sshd,,dnl
,dnl
# jailup sshd dir jailname jailaddr [port]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dev - one of jailup devfull devices
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system sshd useddnl
)

keygen=/usr/bin/ssh-keygen
mount=/sbin/mount
jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user=root
group=wheel
port="${4:-22}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/ssh"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(auth.conf host.conf hosts protocols resolv.conf ssh/moduli)
pams="pam_krb5 pam_login_access pam_nologin pam_opie pam_opieaccess pam_permit pam_ssh pam_unix"
for i in ${pams}; do
    echo "/usr/lib/${i}.so" | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
done
${up_shlib} "${main_dir}/lib" << EOF
    `echo /usr/sbin/sshd | ${up_ldsh}`
    /usr/lib/pam_krb5.so
    /usr/lib/pam_login_access.so
    /usr/lib/pam_nologin.so
    /usr/lib/pam_opie.so
    /usr/lib/pam_opieaccess.so
    /usr/lib/pam_permit.so
    /usr/lib/pam_ssh.so
    /usr/lib/pam_unix.so
EOF

${up_libexe} "${main_dir}/libexec" << EOF
    ld-elf.so.1
    sshd
EOF

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
if  [ ! -e "${conf_dir}/group" ]; then
    ${cat} << "EOF" > "${conf_dir}/group"
wheel:*:0:
sshd:*:22:
nogroup:*:65533:
nobody:*:65534:
EOF
fi

if  [ ! -e "${conf_dir}/master.template" ]; then
    ${cat} << "EOF" > "${conf_dir}/master.template"
root:*:0:0::0:0:Charlie &:/:/nonexistent
sshd:*:22:22::0:0:Secure Shell Daemon:/var/empty:/nonexistent
nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
EOF
fi

if  [ ! -e "${conf_dir}/master.passwd" ]; then
    ${cp} -p "${conf_dir}/master.template" "${conf_dir}/master.passwd"
fi

cf="sshd_config"; if  [ -e "${conf_dir}/ssh/${cf}" ]; then cf="${cf}.sample"; fi
${cp} "${TEMPLATE}" "${conf_dir}/ssh/${cf}"
cm="pam.conf"; if  [ -e "${conf_dir}/${cm}" ]; then cm="${cm}.sample"; fi
${cp} "${TEMPLATE}-pam" "${conf_dir}/${cm}"
${cat} << "EOF" >> "${conf_dir}/hosts.allow"
sshd : ALL : deny
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    auth.conf
    group
    host.conf
    hosts
    hosts.allow
    localtime
    pam.conf
    protocols
    resolv.conf
    master.passwd	mode=0600
    ssh			type=dir mode=0700
/set mode=0600
        moduli
        sshd_config
        sshd_config.sample
        ssh_host_dsa_key
        ssh_host_key
        ssh_host_rsa_key
    ..
..
EOF
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"
[ ! -e "${conf_dir}/ssh/ssh_host_key" ] && ${keygen} -t rsa1 -N "" -f "${conf_dir}/ssh/ssh_host_key"
[ ! -e "${conf_dir}/ssh/ssh_host_rsa_key" ] && ${keygen} -t rsa -N "" -f "${conf_dir}/ssh/ssh_host_rsa_key"
[ ! -e "${conf_dir}/ssh/ssh_host_dsa_key" ] && ${keygen} -t dsa -N "" -f "${conf_dir}/ssh/ssh_host_dsa_key"

${cat} << EOF >> "${genconfig}"
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${user}	${group}	${port}
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#devfs			${main_dir}/dev	devfs	rw		0 0
#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF

${cat} << EOF >> "${STARTUPDIR}/devfs"
${jdir}	full	sshd
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
